Loading...
Searching...
No Matches
opengv::absolute_pose::AbsoluteMultiAdapterBase Class Referenceabstract

`#include <AbsoluteMultiAdapterBase.hpp>`

Inheritance diagram for opengv::absolute_pose::AbsoluteMultiAdapterBase:

## Public Member Functions

EIGEN_MAKE_ALIGNED_OPERATOR_NEW | AbsoluteMultiAdapterBase ()
| Constructor.
| AbsoluteMultiAdapterBase (const opengv::rotation_t &R)
| Constructor.
| AbsoluteMultiAdapterBase (const opengv::translation_t &t, const opengv::rotation_t &R)
| Constructor.
virtual | ~AbsoluteMultiAdapterBase ()
| Destructor.
virtual opengv::bearingVector_t | getBearingVector (size_t frameIndex, size_t correspondenceIndex) const =0
| Retrieve the bearing vector of a correspondence in a certain frame.
virtual double | getWeight (size_t frameIndex, size_t correspondenceIndex) const =0
| Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.
virtual opengv::translation_t | getMultiCamOffset (size_t frameIndex) const =0
| Retrieve the position of a camera seen from the viewpoint origin.
virtual opengv::rotation_t | getMultiCamRotation (size_t frameIndex) const =0
| Retrieve the rotation from a camera to the viewpoint frame.
virtual opengv::point_t | getPoint (size_t frameIndex, size_t correspondenceIndex) const =0
| Retrieve the world point of a correspondence.
virtual size_t | getNumberCorrespondences (size_t frameIndex) const =0
| Retrieve the number of correspondences for a camera.
virtual size_t | getNumberFrames () const =0
| Retrieve the number of cameras.
virtual std::vector< int > | convertMultiIndices (const std::vector< std::vector< int > > &multiIndices) const =0
| Convert an array of (frameIndex,correspondenceIndex)-pairs into an array of serialized indices.
virtual int | convertMultiIndex (size_t frameIndex, size_t correspondenceIndex) const =0
| Convert a (frameIndex,correspondenceIndex)-pair into a serialized index.
virtual int | multiFrameIndex (size_t index) const =0
| Get the frame-index corresponding to a serialized index.
virtual int | multiCorrespondenceIndex (size_t index) const =0
| Get the correspondence-index in a camera for a serialized index.
virtual bearingVector_t | getBearingVector (size_t index) const
virtual double | getWeight (size_t index) const
virtual translation_t | getCamOffset (size_t index) const
virtual rotation_t | getCamRotation (size_t index) const
virtual point_t | getPoint (size_t index) const
virtual size_t | getNumberCorrespondences () const
Public Member Functions inherited from opengv::absolute_pose::AbsoluteAdapterBase
EIGEN_MAKE_ALIGNED_OPERATOR_NEW | AbsoluteAdapterBase ()
| Constructor.
| AbsoluteAdapterBase (const opengv::rotation_t &R)
| Constructor.
| AbsoluteAdapterBase (const opengv::translation_t &t, const opengv::rotation_t &R)
| Constructor.
virtual | ~AbsoluteAdapterBase ()
| Destructor.
opengv::translation_t | gett () const
| Retrieve the prior or known value for the position.
void | sett (const opengv::translation_t &t)
| Set the prior or known value for the position.
opengv::rotation_t | getR () const
| Retrieve the prior or known value for the rotation.
void | setR (const opengv::rotation_t &R)
| Set the prior or known value for the rotation.

## Protected Attributes

opengv::translation_t | _t
opengv::rotation_t | _R
Protected Attributes inherited from opengv::absolute_pose::AbsoluteAdapterBase
opengv::translation_t | _t
opengv::rotation_t | _R

## Detailed Description

See the documentation of AbsoluteAdapterBase to understand the meaning of an AbsoluteAdapter. AbsoluteMultiAdapterBase extends the interface of AbsoluteAdapterBase by an additional frame-index for referring to a camera. Intended for non-central absolute viewpoint problems, allowing camera-wise access of correspondences. Derived classes need to implement functionalities for deriving unique serialization of multi-indices.

## Constructor & Destructor Documentation

## AbsoluteMultiAdapterBase() [1/2]

opengv::absolute_pose::AbsoluteMultiAdapterBase::AbsoluteMultiAdapterBase | ( | const opengv::rotation_t & | R | ) |

inline

Constructor.

Parameters

  [in] | R | A prior or known value for the rotation from the viewpoint to the world frame.

## AbsoluteMultiAdapterBase() [2/2]

opengv::absolute_pose::AbsoluteMultiAdapterBase::AbsoluteMultiAdapterBase | ( | const opengv::translation_t & | t,
|  | const opengv::rotation_t & | R )

inline

Constructor.

Parameters

  [in] | t | A prior or known value for the position of the viewpoint seen from the world frame.
  [in] | R | A prior or known value for the rotation from the viewpoint to the world frame.

## Member Function Documentation

## convertMultiIndex()

virtual int opengv::absolute_pose::AbsoluteMultiAdapterBase::convertMultiIndex | ( | size_t | frameIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Convert a (frameIndex,correspondenceIndex)-pair into a serialized index.

Parameters

  [in] | frameIndex | The index of the camera.
  [in] | correspondenceIndex | The index of the correspondence in the camera.

Returns
  Array of single serialized indices referring uniquely to (frameIndex,correspondenceIndex)-pairs.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## convertMultiIndices()

virtual std::vector< int > opengv::absolute_pose::AbsoluteMultiAdapterBase::convertMultiIndices | ( | const std::vector< std::vector< int > > & | multiIndices | ) | const

pure virtual

Convert an array of (frameIndex,correspondenceIndex)-pairs into an array of serialized indices.

Parameters

  [in] | multiIndices | Array of (frameIndex,correspondenceIndex)-pairs.

Returns
  Array of single serialized indices referring uniquely to (frameIndex,correspondenceIndex)-pairs.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getBearingVector() [1/2]

virtual opengv::bearingVector_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getBearingVector | ( | size_t | frameIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the bearing vector of a correspondence in a certain frame.

Parameters

  [in] | frameIndex | Index of the frame.
  [in] | correspondenceIndex | Index of the correspondence in this frame.

Returns
  The corresponding bearing vector.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getBearingVector() [2/2]

virtual bearingVector_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getBearingVector | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## getCamOffset()

virtual translation_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getCamOffset | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## getCamRotation()

virtual rotation_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getCamRotation | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## getMultiCamOffset()

virtual opengv::translation_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getMultiCamOffset | ( | size_t | frameIndex | ) | const

pure virtual

Retrieve the position of a camera seen from the viewpoint origin.

Parameters

  [in] | frameIndex | Index of the frame.

Returns
  The position of the corresponding camera seen from the viewpoint origin.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getMultiCamRotation()

virtual opengv::rotation_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getMultiCamRotation | ( | size_t | frameIndex | ) | const

pure virtual

Retrieve the rotation from a camera to the viewpoint frame.

Parameters

  [in] | frameIndex | Index of the frame.

Returns
  The rotation from the corresponding camera back to the viewpoint origin.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getNumberCorrespondences() [1/2]

virtual size_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getNumberCorrespondences | ( |  | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## getNumberCorrespondences() [2/2]

virtual size_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getNumberCorrespondences | ( | size_t | frameIndex | ) | const

pure virtual

Retrieve the number of correspondences for a camera.

Parameters

  [in] | frameIndex | Index of the camera.

Returns
  The number of correspondences in this camera.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getNumberFrames()

virtual size_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getNumberFrames | ( |  | ) | const

pure virtual

Retrieve the number of cameras.

Returns
  The number of cameras.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getPoint() [1/2]

virtual opengv::point_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getPoint | ( | size_t | frameIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the world point of a correspondence.

Parameters

  [in] | frameIndex | Index of the frame.
  [in] | correspondenceIndex | Index of the correspondence in this frame.

Returns
  The corresponding world point.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getPoint() [2/2]

virtual point_t opengv::absolute_pose::AbsoluteMultiAdapterBase::getPoint | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## getWeight() [1/2]

virtual double opengv::absolute_pose::AbsoluteMultiAdapterBase::getWeight | ( | size_t | frameIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.

Parameters

  [in] | frameIndex | Index of the frame.
  [in] | correspondenceIndex | Index of the correspondence in this frame.

Returns
  The corresponding weight.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## getWeight() [2/2]

virtual double opengv::absolute_pose::AbsoluteMultiAdapterBase::getWeight | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::absolute_pose::AbsoluteAdapterBase.

## multiCorrespondenceIndex()

virtual int opengv::absolute_pose::AbsoluteMultiAdapterBase::multiCorrespondenceIndex | ( | size_t | index | ) | const

pure virtual

Get the correspondence-index in a camera for a serialized index.

Parameters

  [in] | index | The serialized index.

Returns
  The correspondence-index in the camera.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## multiFrameIndex()

virtual int opengv::absolute_pose::AbsoluteMultiAdapterBase::multiFrameIndex | ( | size_t | index | ) | const

pure virtual

Get the frame-index corresponding to a serialized index.

Parameters

  [in] | index | The serialized index.

Returns
  The frame index.

Implemented in opengv::absolute_pose::NoncentralAbsoluteMultiAdapter.

## Member Data Documentation

## _R

opengv::rotation_t opengv::absolute_pose::AbsoluteAdapterBase::_R

protected

The prior or known value for the rotation from the viewpoint back to the world frame. Initialized to identity if not provided.

## _t

opengv::translation_t opengv::absolute_pose::AbsoluteAdapterBase::_t

protected

The prior or known value for the position of the viewpoint seen from the world frame. Initialized to zero if not provided.

The documentation for this class was generated from the following file:

- include/opengv/absolute_pose/AbsoluteMultiAdapterBase.hpp